<?php
require_once('config.php');
require_once('future.php');

$data = array();

if (strlen($_POST['func'])) {
  $backend = new AJAXBackend();

  if (method_exists($backend, $_POST['func'])) {
    $func = $_POST['func'];
    json_return($backend->$func());
  }

  $path = substr($_SERVER['HTTP_REFERER'], strpos($_SERVER['HTTP_REFERER'], $_SERVER['SERVER_NAME'])+strlen($_SERVER['SERVER_NAME'])+1);
  $slash = strpos($path, '/', strpos($path, '/')+1);

  if ($slash !== false) {
    $path = getcwd() . '/' . substr($path, 0, $slash) . '/' . 'moduleajaxbackend.class.php';

    if (file_exists($path)) {
      require_once($path);
      $backend = new ModuleAJAXBackend();

      if (method_exists($backend, $_POST['func'])) {
	$func = $_POST['func'];
	json_return($backend->$func());
      }
    }
  }

  error_log('Unknown function '.$_POST['func']);
  json_return(array('status' => false,
		    'error' => 'Unknown function '.urlencode($_POST['func']).'.'));
}

error_log('Unknown usage');
json_return(array('status' => false, 'error' => 'Unknown usage'));

